unit fonctions_persistentforms;
// Unité de la Version 2 du projet FormMain
// La version 1 TFormMain n'est pas sa fenêtre parente

// Le module crée des propriété servant à la gestion du fichier INI
// Il gère la déconnexion
// Il gère la gestion des touches majuscules et numlock
// Il gère les forms enfants
// créé par Matthieu Giroux en décembre 2007

{$I ..\DLCompilers.inc}
{$I ..\extends.inc}

interface

{$IFDEF FPC}
{$mode Delphi}
{$ENDIF}

uses
{$IFDEF SFORM}
  CompSuperForm,
{$ENDIF}
  {$IFDEF EADO}
     ADODB,
  {$ENDIF}
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
{$IFDEF TNT}
  TNTForms,
{$ENDIF}
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
{$IFDEF FPC}
  LCLIntf, LCLType,
{$ELSE}
  Windows, OleDb, Messages,
{$ENDIF}
  Dialogs, ExtCtrls, fonctions_ini;

{$IFDEF VERSIONS}
  const
    gVer_fonctions_persistentforms : T_Version = (  Component : 'Gestion de Fenêtres' ;
                                       FileUnit : 'fonctions_forms' ;
                                       Owner : 'Matthieu Giroux' ;
                                       Comment : 'Fiche principale deuxième version.' ;
                                       BugsStory : '0.9.0.0 : Create unique form.';
                                       UnitType : 3 ;
                                       Major : 0 ; Minor : 9 ; Release : 0 ; Build : 0 );

{$ENDIF}

// Création d'une form MDI renvoie True si la form existe
// as_FormNom : Nom de la form ; afor_FormClasse : Classe de la form ; var afor_Reference : Variable de la form
function fp_CreateUniqueChild ( const as_FormNom, as_FormClasse : string ; const newFormStyle : TFormStyle; const ab_Ajuster : Boolean = True ; const aico_Icon : TIcon = nil): Pointer; overload;


var
  gb_ModalStarted : Boolean;


implementation

uses fonctions_proprietes, fonctions_erreurs, TypInfo,
  fonctions_system, fonctions_persistent,
  fonctions_forms;

{ fonctions }

// Création d'une form MDI renvoie True si la form existe dans les enfants MDI
// as_FormNom        : nom      de la form
// afor_FormClasse   : classe   de la form
// newFormStyle      : style    de la form à mettre
function fp_CreateUniqueChild(const as_FormNom, as_FormClasse: string; const newFormStyle: TFormStyle; const ab_Ajuster: Boolean = True ; const aico_Icon : TIcon = nil): Pointer;
var
  lper_ClasseForm : TFormClass ;
  lb_Unload : Boolean ;

begin
  // Recherche la form
  Result    := ffor_getForm ( as_FormNom, as_FormClasse );

  // Form non trouvée : on crée
  if not Assigned(Result) then
    Begin
        // Recherche la classe de la form dans cette unité
        lper_ClasseForm := TFormClass ( fper_FindClass ( as_FormClasse ));

        if Assigned(lper_ClasseForm)
        // Rapide : on a trouvé la form dans cette unité
         Then Result := ffor_CreateForm ( lper_ClasseForm )
         Else
           Begin
             try
              // Recherche la classe de la form dans delphi
               lper_ClasseForm := TFormClass ( FindClass ( as_FormClasse ));
             except
             End ;
             // Lent form trouvée dans delphi
             if Assigned(lper_ClasseForm)
              Then
               Result := ffor_CreateForm ( lper_ClasseForm );
           End ;
    // Assigne l'icône si existe
      If assigned ( aico_Icon    )
      and Assigned( Result )
       Then
        Begin
          ( TForm ( Result )).Icon.Modified := False ;
          ( TForm ( Result )).Icon.PaletteModified := False ;
          if ( TForm ( Result )).Icon.Handle <> 0 Then
            Begin
              ( TForm ( Result )).Icon.ReleaseHandle ;
              ( TForm ( Result )).Icon.CleanupInstance ;
            End ;
          ( TForm ( Result )).Icon.Handle := 0 ;
          ( TForm ( Result )).Icon.width  := 16 ;
          ( TForm ( Result )).Icon.Height := 16 ;
          ( TForm ( Result )).Icon.Assign ( aico_Icon );
          ( TForm ( Result )).Icon.Modified := True ;
          ( TForm ( Result )).Icon.PaletteModified := True ;

          ( TForm ( Result )).Invalidate ;

        End ;

//      ShowMessage('Fiche ' + afor_FormClasse + ' non enregistrée ( Utiliser RegisterClasses dans la création du projet )');
    end;
    // Paramètre d'affichage
  if Assigned(Result)
  and ab_Ajuster then
    Begin
      lb_Unload := fb_getComponentBoolProperty ( TComponent( Result ), 'DataUnload' );
      if not lb_Unload Then
        fb_setNewFormStyle( TForm ( Result ), newFormStyle, ab_Ajuster)
      else 
        ( TForm ( Result )).Free ;
    End ;
end;



initialization
{$IFDEF VERSIONS}
  p_ConcatVersion ( gVer_fonctions_persistentforms );
{$ENDIF}
end.
