unit fonctions_objets_dynamiques;

interface

{$I ..\extends.inc}
{$I ..\DLCompilers.inc}
{$IFDEF DELPHI}
   {$R *.res}
{$ENDIF}

{

Créée par Matthieu Giroux le 01-2004

Fonctionnalités :

Création de la barre d'accès
Création du menu d'accès
Création du volet d'accès

Utilisation des fonctions
Administration

}

uses Forms, JvXPBar,
{$IFDEF FPC}
   LCLIntf, LCLType, ComCtrls,
   JvXPButtons, gettext, Translations,
{$ELSE}
   Windows, ToolWin, JvXPButtons,
{$ENDIF}
  u_multidata,
  Controls, Classes, ExtCtrls,
  Menus, IniFiles,
  fonctions_manbase,
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
{$IFDEF DELPHI_9_UP}
  WideStrings ,
{$ENDIF}
{$IFDEF TNT}
  DKLang,
{$ENDIF}
  DBCtrls, Graphics,
  fonctions_string ;

var
      gb_ExisteFonctionMenu   : Boolean      ;   // Existe-t-il une fonction d'accès au menu

const // Evènements gérés
  CST_EVT_STANDARD    = 'OnCLick' ;
  // Nom par défaut des composants
  CST_XPBAR_NOM_DEBUT  = 'xpb_Menu' ;
  CST_MENU_NOM_DEBUT   = 'men_Menu' ;
  CST_XPITEM_NOM_DEBUT = 'xpi_SMenu' ; // Nom par défaut du xp item
  CST_DBT_NOM_DEBUT    = 'dbt_Sommaire' ;
  CST_SEP_NOM_DEBUT    = 'tbsep_Sommaire' ;
  CST_PANEL_NOM_DEBUT    = 'pan_Sommaire' ;
  // Types de fonctions gérées
  CST_FCT_TYPE_MENU   = 'MENU' ;
  CST_FCT_TYPE_FICHE  = 'FICHE' ;
  CST_FCT_MODE_MODAL  = 'MODAL' ;
  CST_FCT_NOM_TOUT    = 'TOUT' ;
  CST_LANG_MENU_ITEM = 'LangMenuItem';
  CST_FONCTION_CLICK  = 'p_OnClickFonction' ;
  CST_FONCTION_LANG   = 'p_OnClickMenuLang' ;

{$IFDEF VERSIONS}
  gver_fonctions_Objets_Dynamiques : T_Version = ( Component : 'Gestion des objets dynamiques' ; FileUnit : 'fonctions_Objets_Dynamiques' ;
              			                 Owner : 'Matthieu Giroux' ;
              			                 Comment : 'Gestion des objets dynamiques du composant Fenêtre principale.' + #13#10 + 'Il comprend une création de menus' ;
              			                 BugsStory : 'Version 1.3.0.2 : No ExtToolBar.' + #13#10 +
                                                 'Version 1.3.0.1 : No ExtToolBar on Lazarus.' + #13#10 +
                                                 'Version 1.3.0.0 : Création fonction_objets_data' + #13#10 +
                                                 'Version 1.2.0.0 : Passage en générique' + #13#10 +
                                                 'Version 1.1.2.0 : raccourcis d''aide répétés.' + #13#10 +
                                                 'Version 1.1.1.1 : Ne pas utiliser HandleAllocated mais Handle <> 0.' + #13#10 +
                                                 'Version 1.1.1.0 : Sauvegarde de la visibilité des barres de menus.' + #13#10 +
                                                 'Version 1.1.0.0 : Passage en Jedi 3, Utilisation de la JvXPBar.' + #13#10 +
                                                 'Version 1.0.1.3 : Mises à jour sur la destruction.' + #13#10 +
                                                 'Version 1.0.1.2 : Handle à 0 après FreeImage.' + #13#10 +
                                                 'Version 1.0.1.1 : Suppression du RealeaseHandle après FreeImage.' + #13#10 +
                                                 'Version 1.0.1.0 : Toutes les fonctions peuvent être appelées.' + #13#10 +
                                                 'Version 1.0.0.2 : Gestion des caractères accentuées.' + #13#10 +
                                                 'Version 1.0.0.1 : Meilleure gestion des images, problèmes de rafraichissement.' + #13#10 +
                                                 'Version 1.0.0.0 : La création est utilisée par Fenêtre Principale.';
              			                 UnitType : 1 ;
              			                 Major : 1 ; Minor : 3 ; Release : 0 ; Build : 2 );
{$ENDIF}


function fb_LoadData ( const aif_IniFile : TIniFile ; const as_SectionName : String;
                       const ads_connection : TDSSource ; var abm_DatabaseToGenerate : TFWBaseMode;
                       const acom_owner : TComponent;
                       const aDefaultBaseDriver : String = '';
                       const aDefaultBaseNet : String = '' ;
                       const aDefaultBasePath : String = '' ;
                       const aDefaultBaseUser : String = '' ;
                       const aDefaultBasePassword : String = '' ):Boolean;
procedure p_setImageToMenuAndXPButton ( const abmp_Bitmap: TBitmap;
                                        const axb_Button  : TJvXPButton ;
                                        const amen_Menu   : TMenuItem ;
                                        const aiml_Images : TImageList  );


procedure p_AjouteFonctionMenu  ( const aF_FormParent        : TForm     ;
                        			    const aMen_MenuParent     : TMenuItem ;
                        			    const as_Fonction          ,
                        			          as_FonctionLibelle   ,
                        			          as_FonctionType      ,
                        			          as_FonctionMode      ,
                        			          as_FonctionNom       : String      ;
                        			    const ai_Compteur          : integer     ;
                        			    const aBmp_Picture         : TBitmap     ;
                        			    const ab_AjouteBitmap      ,
                        			          ab_ImageDefaut       : Boolean     ;
                        			    const aIma_ImagesMenus     : TImageList  ;
                        			    const ai_FinCompteurImages : Integer     );
procedure p_AjouteEvenement       ( const aF_FormParent       : TComponent  ;
        			    const aObj_Objet          : TObject     ;
        			    const as_Fonction         ,
                                          as_EventForm        ,
        			          as_Evenement        : String     );
function fcom_FindComponent ( const as_Name : String ; const AOwner : TComponent ): TComponent;
procedure p_InitButtons ( const anav_Navigateur : TDBNavigator );
procedure  p_EnableSommaire (       const aBar_ToolBarParent      : {$IFDEF FPC}TCustomControl{$ELSE}TToolWindow{$ENDIF}  ;
                        			      const aSep_ToolBarSepareDebut : TControl;
                        			      const aPan_PanelSepareFin     : TWinControl  );
function fIco_getIcon ( const aobj_Sender : Tobject ): TIcon;
function fs_getIniOrCreateIniValue ( const FIni : TIniFile ; const as_Value : String ; const ADefaultValue : String = '' ) : String;

// Gestion des noms
function fs_getComponentName ( const acom_Owner : TComponent ; const as_Name : String ):String;
procedure p_setComponentName ( const acom_Component : TComponent ; const as_Name : String );
function fs_getComponentNameXPBar ( const adx_WinXpBar        : TJvXpBar ; const as_Name : String ):String;

procedure  p_DetruitSommaire (      const aBar_ToolBarParent      : {$IFDEF FPC}TCustomControl{$ELSE}TToolWindow{$ENDIF}   ;
                                    const aSep_ToolBarSepareDebut : TControl;
                                    const aPan_PanelSepareFin     : TWinControl  );

procedure p_DetruitMenus ( const aMen_MenuParent : TMenuItem ; aMen_MenuDetruit  : TMenuItem  ; const ab_DestroyAll : Boolean    );


procedure p_DetruitXPBar ( const   aCom_Parent    : TScrollingWinControl );

procedure p_ShowMessageMethode ( const as_Fonction          ,
                                       as_Evenement         ,
                                       aF_FormParentClasse  ,
                                       aCom_ComposantClasse : String );

procedure p_ModifieXPBar  ( const aF_FormParent       : TCustomForm        ;
                            const adx_WinXpBar        : TJvXpBar ;
                            const as_Fonction         ,
                                  as_FonctionLibelle  ,
                                  as_FonctionType     ,
                                  as_FonctionMode     ,
                                  as_FonctionNom      : String      ;
                            const aIma_ListeImages    : TImageList  ;
                            const abmp_Picture        ,
                                  abmp_DefaultPicture : TBitmap     ;
                            const ab_AjouteEvenement  : Boolean     );
function fdxi_AddItemXPBar  ( const aF_FormParent       : TCustomForm        ;
                        			const adx_WinXpBar        : TJvXpBar ;
                        			const as_Fonction         ,
                        			      as_FonctionLibelle  ,
                        			      as_FonctionType     ,
                        			      as_FonctionMode     ,
                        			      as_FonctionNom      : String      ;
                        			const aIma_ImagesXPBars   : TImageList  ;
                        			const abmp_FonctionBmp    : TBitmap     ;
                        			const aBmp_DefaultPicture : TBitmap     ;
                        			const ai_CompteurNom      : integer     ): TJvXpBarItem ;
function fmen_AjouteFonctionMenu  ( const aF_FormParent        : TForm     ;
                        			    const aMen_MenuParent     : TMenuItem ;
                        			    const as_Fonction          ,
                        			          as_FonctionLibelle   ,
                        			          as_FonctionType      ,
                        			          as_FonctionMode      ,
                        			          as_FonctionNom       : String      ;
                        			    const ai_Compteur          : integer     ;
                        			    const aBmp_Picture         : TBitmap     ;
                        			    const ab_AjouteBitmap      ,
                        			          ab_ImageDefaut       : Boolean     ;
                        			    const aIma_ImagesMenus     : TImageList  ;
                        			    const ai_FinCompteurImages : Integer     ):TMenuItem;
procedure CreateLanguagesController ( const Items : TMenuItem );

implementation

uses U_FormMainIni, SysUtils, TypInfo, Dialogs,
     fonctions_system,
     fonctions_images,
     fonctions_dialogs,
     fonctions_scaledpi,
     fonctions_dbobjects,
     fonctions_ini,
     fonctions_file,
     LazFileUtils,
     unite_messages,
     strutils,
{$IFDEF TNT}
     TntSysUtils, TntSystem,
{$ENDIF}
     unite_variables, Variants, fonctions_proprietes,
     fonctions_languages;


procedure CreateLanguagesController ( const Items : TMenuItem );
var i: Integer;
    MenuItem : TMenuItem ;
    lsr_AttrLangeFile      : Tsearchrec;
begin
  {$IFDEF TNT}
  Languages := TDKLanguageController.Create ( Application );
   // Scan for language files in the app directory and register them in the LangManager object
  LangManager.ScanForLangFiles(WideExtractFileDir(WideParamStr(0)), '*.lng', False);
  {$ENDIF}
   // Fill cbLanguage with available languages
  Items.Clear;
  for i := 0 to {$IFNDEF TNT}high ( ga_SoftwareLanguages ){$ELSE}LangManager.LanguageCount-1{$ENDIF} do
    Begin
     MenuItem := TMenuItem.Create ( Items.Owner );
     MenuItem.Caption := {$IFNDEF TNT}ga_SoftwareLanguages [ i ].LongLang{$ELSE}LangManager.LanguageNames[i]{$ENDIF};
     MenuItem.Name := CST_LANG_MENU_ITEM + IntToStr ( i + 1 );
     p_AjouteEvenement ( Items.Owner            ,
                          MenuItem                 ,
                          '',
                          CST_FONCTION_LANG        ,
                          CST_EVT_STANDARD         );
     MenuItem.Tag := i;
     Items.Add(MenuItem);
    End;
   // Index=0 always means the default language
//    cbLanguage.ItemIndex := 0;
end;

/////////////////////////////////////////////////////////////////////////
// function fs_getIniOrNotIniValue
// Loading  from ini
// as_Value : Value to find from ini
/////////////////////////////////////////////////////////////////////////
function fs_getIniOrCreateIniValue ( const FIni : TIniFile ; const as_Value : String ; const ADefaultValue : String = '' ) : String;
Begin
  if  ( as_Value <> '' )
  and Assigned(FIni)
   Then
     Begin
       Result := FIni.ReadString( INISEC_PAR, as_Value, '' );
       if Result = '' Then
         FIni.WriteString( INISEC_PAR, as_Value, ADefaultValue );
     end
   else Result := as_Value;
End;

function fb_AutoCreateDatabase ( const as_BaseName, as_user, as_password, as_host : String ; const ab_DoItWithCommandLine : Boolean ; const acom_owner : TComponent ; const ads_connection : TDSSource = nil ):Boolean;
var li_i : Integer;
    LTables : TFWTables;
    ATemp1,
    ATemp2 : String;
Begin
  doShowWorking(gs_Message_Creating_database);
  try
    {fs_BuildTreeFromXML ( 0, gxdo_FichierXML.Node, TOnExecuteProjectNode ( p_onProjectInitNode ) ) ;
    LTables := TFWTables.Create(TFWTable);
    try
      // create table objects
      for li_i := 0 to high ( ga_Functions ) do
       with ga_Functions [li_i] do
         Begin
           if AFile = ''
            Then ATemp1:=Name
            Else ATemp1:=AFile;
           if  ( ATemp1 > '' )
           and ( LTables.TableByName(ATemp1) = nil ) Then
             p_CreateComponents( LTables, ATemp1, Name, acom_owner, nil, gxdo_FichierXML, TOnExecuteFieldNode ( p_OnCreateFieldProperties), nil, nil, False, False );
         end;
      ATemp1:=fs_BeginAlterCreate+fs_CreateDatabase(as_BaseName,as_user,as_password, as_host);
      ATemp2:=fs_BeginAlterCreate;
      for li_i := 0 to LTables.Count - 1 do
       with LTables [ li_i ] do
        if IsMain Then
         Begin
           //MyShowMessage(Table+#10+GetSQLCreateCode);
           AppendStr(ATemp2,GetSQLCreateCode);
         end;
      AppendStr(ATemp2,fs_EndCreate(as_BaseName,as_user,as_password,as_host));
    finally
      LTables.destroy;
    end;
    try
      if ab_DoItWithCommandLine Then
        p_ExecuteSQLCommand(ATemp1+ATemp2)
      Else
       if Assigned(ge_ExecuteSQLScript)
        Then ge_ExecuteSQLScript ( as_BaseName, as_user, as_password,as_host, ATemp1, ATemp2, ads_connection );
      p_optimiseDatabase(nil,as_BaseName,as_user,as_password,fs_GetIniDir(False));
      Result := True;
    except
      Result := False;
    end;
                   }
  finally
    doCloseWorking;
  end;
End;


/////////////////////////////////////////////////////////////////////////
// Procédure p_Loaddata
// Loading data link
// Charge le lien de données
// axno_Node : xml data document
/////////////////////////////////////////////////////////////////////////
function fb_LoadData ( const aif_IniFile : TIniFile ; const as_SectionName : String;
                       const ads_connection : TDSSource ; var abm_DatabaseToGenerate : TFWBaseMode;
                       const acom_owner : TComponent;
                       const aDefaultBaseDriver : String = '';
                       const aDefaultBaseNet : String = '' ;
                       const aDefaultBasePath : String = '' ;
                       const aDefaultBaseUser : String = '' ;
                       const aDefaultBasePassword : String = '' ):Boolean;
var li_i : LongInt ;
    li_Pos : LongInt ;
    lds_connection : TDSSource;
    ls_ConnectionClep : String;
    AParams : TStrings;
Begin
  Result := False;
  if not assigned ( aif_IniFile ) Then
   Exit;
  // Le module M_Donnees n'est pas encore chargé
  with ads_connection do
   Begin
    DataLocal:=False;
    DataURL := fs_getIniOrCreateIniValue ( aif_IniFile,CST_SQL_DATA_URL, aDefaultBaseNet );
    if DataURL = ''
      Then DataBase:= fs_getIniOrCreateIniValue ( aif_IniFile,CST_SQL_DATA_DATABASE, aDefaultBasePath )
      Else
        Begin
          li_Pos := pos ( '//', DataURL );
          DataURL := copy ( DataURL , li_pos + 2, length ( DataURL ) - li_pos - 1 );
          DataPort := 0;
          li_Pos := pos ( ':', DataURL );
          if li_Pos > 0 Then
            DataURL := copy ( DataURL , li_pos + 1, length ( DataURL ) - li_pos );
          li_Pos := pos ( ':', DataURL );
          // Récupération du port
          if li_Pos > 0 Then
            try
              if pos ( '/', DataURL ) > 0
               Then  DataPort    := StrToInt ( copy ( DataURL, li_Pos + 1, pos ( '/', DataURL ) - li_pos - 1 ))
               Else  DataPort    := StrToInt ( copy ( DataURL, li_Pos + 1, length ( DataURL ) - li_pos ));
              // Finition de l'URL : Elle ne contient que l'adresse du serveur
              DataURL := copy ( DataURL , 1, li_Pos - 1 );
            Except
            end;
          li_Pos:=pos ( '=', DataURL );
          if ( li_Pos > 1 )
           Then
            Begin
             if pos ( fs_GetSoftName, DataURL ) = li_pos+1 Then
               li_Pos:=posEx ( '/', DataURL, li_pos );
             DataBase:=fs_GetCorrectPath(copy(DataURL,li_Pos+1,Length(DataURL)-li_Pos));
             if not fb_IsFullPath(DataBase) Then
              if pos('localhost',lowercase(DataURL))>0
              Then DataBase:=GetDataDir+DataBase
              Else DataBase:=GetAppDir +DataBase;
             if not fb_CreateDirectoryStructure(ExtractFilePath(DataBase)) Then
              Begin
               MyShowMessage(fs_RemplaceMsg(GS_CANNOT_CREATE_DIR_EXITING,[ExtractFilePath(DataBase)]));
               Exit;
              End;
             DataLocal:=True;
            end
           else
             Database := fs_getIniOrCreateIniValue ( aif_IniFile,CST_SQL_DATA_DATABASE, aDefaultBasePath );
       if ( DataURL [ length ( DataURL )] = '/' ) Then
         DataURL := copy ( DataURL , 1, length ( DataURL ) - 1 );
       if pos('localhost',lowercase(DataURL))>0 Then
          DataLocal := True;
      end;
     DataUser := fs_getIniOrCreateIniValue ( aif_IniFile,CST_SQL_DATA_USER, aDefaultBaseUser );
     DataPassword :=fs_getIniOrCreateIniValue ( aif_IniFile,CST_SQL_DATA_Password, aDefaultBasePassword );
     DataDriver := fs_getIniOrCreateIniValue ( aif_IniFile,CST_SQL_DATA_DRIVER, aDefaultBaseDriver );
     if DataUser = '' Then
       fb_iniWriteFile(FIniFile,True)
      Else
       Begin
         p_setComponentProperty ( DataConnection, 'User', DataUser );
         p_setComponentProperty ( DataConnection, 'Password', DataPassword );
         if not DataLocal Then
           p_setComponentProperty ( DataConnection, 'Hostname', DataURL );
         p_setComponentProperty ( DataConnection, CST_SQL_DATABASE, Database );
         p_setComponentProperty ( DataConnection, 'DatabaseName', Database );
         if DataPort > 0 Then
           p_setComponentProperty ( DataConnection, 'Port', DataPort );
         if ( pos ( CST_SQL_DATA_MYSQL, DataDriver ) > 0 ) Then
           Begin
            p_setComponentProperty ( DataConnection, CST_SQL_PROTOCOL, CST_SQL_DRIVER_MYSQL );
            abm_DatabaseToGenerate:=bmMySQL;
           end
         else if ( pos ( CST_SQL_DATA_FIREBIRD, DataDriver ) > 0 )
         and ( abm_DatabaseToGenerate = bmFirebird ) Then
          Begin
            AParams := fobj_getComponentObjectProperty(DataConnection,'Params') as TStrings;
            if DataUser = '' Then
             Begin
              DataUser := 'SYSDBA';
              DataPassword:='masterkey';
             End;
            with AParams do
              Begin
               Add('user_name='+DataUser);
               Add('password='+DataPassword);
              end;
          end
         else if ( pos ( CST_SQL_DATA_SQLLITE, DataDriver ) > 0 ) Then
          Begin
           p_setComponentProperty ( DataConnection, CST_SQL_PROTOCOL, CST_SQL_DRIVER_SQLLITE );
          end
         else if ( pos ( CST_SQL_DATA_ORACLE, DataDriver ) > 0 ) Then
          Begin
           p_setComponentProperty ( DataConnection, CST_SQL_PROTOCOL, CST_SQL_DRIVER_ORACLE );
           abm_DatabaseToGenerate:=bmOracle;
          end
         else if ( pos ( CST_SQL_DATA_POSTGRES, DataDriver ) > 0 ) Then
          Begin
           p_setComponentProperty ( DataConnection, CST_SQL_PROTOCOL, CST_SQL_DRIVER_POSTGRES );
           abm_DatabaseToGenerate:=bmPostgreSQL;
          end;
         if DataLocal Then
           if not FileExistsUTF8(DataBase) Then
             fb_AutoCreateDatabase ( DataBase, DataUser, DataPassword, DataURL, True, acom_owner );
         Result := fb_OpenCloseDatabase ( DataConnection, True );
         if not Result
         and (MyMessageDlg('SQL',fs_RemplaceMsg(gs_Could_not_connect_Seems_you_have_not_created_database_Do_you,
                   [fs_getComponentProperty(DataConnection,CST_SQL_DATABASE),
                    fs_getComponentProperty(DataConnection,'User')]),mmtWarning,mmbYesNo) = mrNo) Then
            Result := fb_AutoCreateDatabase(DataBase,DataUser,DataPassword,DataURL,False,acom_owner,ads_connection);
       end;

   end;
End;

// Change les boutons du navigateur bookmark en boutons de déplacements d'enregistrement
// anav_Navigateur : Le navigateur à modifier
procedure p_InitButtons ( const anav_Navigateur : TDBNavigator );
begin

  if not assigned ( anav_Navigateur )
   Then
    Exit ;

//  ResInstance:= FindResourceHInstance(HInstance);
  {
  ( anav_Navigateur.Controls [ 11 ] as TAdvNavButton ).Glyph        .LoadFromResourceName(ResInstance,'NAVBOOKPRIORE');
  ( anav_Navigateur.Controls [ 11 ] as TAdvNavButton ).GlyphDisabled.LoadFromResourceName(ResInstance,'NAVBOOKPRIORD');
  ( anav_Navigateur.Controls [ 11 ] as TAdvNavButton ).GlyphHot     .LoadFromResourceName(ResInstance,'NAVBOOKPRIORH');

  ( anav_Navigateur.Controls [ 12 ] as TAdvNavButton ).Glyph        .LoadFromResourceName(ResInstance,'NAVBOOKNEXTE');
  ( anav_Navigateur.Controls [ 12 ] as TAdvNavButton ).GlyphDisabled.LoadFromResourceName(ResInstance,'NAVBOOKNEXTD');
  ( anav_Navigateur.Controls [ 12 ] as TAdvNavButton ).GlyphHot     .LoadFromResourceName(ResInstance,'NAVBOOKNEXTH');
  if anav_Navigateur.Hints.Count <= 11
   Then  anav_Navigateur.Hints.Add ( 'Déplacer l''enregistrement vers le haut' )
   Else  anav_Navigateur.Hints.Strings [ 11 ] := 'Déplacer l''enregistrement vers le haut' ;
  if anav_Navigateur.Hints.Count <= 12
   Then  anav_Navigateur.Hints.Add ( 'Déplacer l''enregistrement vers le bas' )
   Else anav_Navigateur.Hints.Strings [ 12 ] := 'Déplacer l''enregistrement vers le bas' ;
   }
end;


// Récupère l'icône du bouton de la fonction et le renvoie
// En entrée : le bouton en objet
// En sortie : L'icône récupéré

function fIco_getIcon ( const aobj_Sender : Tobject ): TIcon;
var
    lbmp_Icon        : TBitmap ;
    lima_Liste       : TImageList ;
    lMen_MenuParent  : TMenuitem ;
Begin
  Result := TIcon.Create ;
  Result.Handle := 0 ;
  lbmp_Icon := TBitmap.Create ;
  lbmp_Icon.Handle := 0 ;
  lima_Liste := TImageList.Create ( nil );
  // C'est un bouton
  if ( aobj_Sender is TJvXPButton )
   Then
    Begin
      lbmp_Icon.Assign( ( aobj_Sender as TJvXPButton ).Glyph );
      p_RecuperePetitBitmap ( lbmp_Icon );
      lima_Liste.AddMasked ( lbmp_Icon, lbmp_Icon.TransparentColor );
      lima_Liste.GetBitmap ( lima_Liste.Count - 1, lbmp_Icon );
      p_BitmapVersIco(lbmp_Icon,Result);
    End ;
    // C'est un menu
  if ( aobj_Sender is TMenuItem )
   Then
    Begin
      lMen_MenuParent := aobj_Sender as TMenuItem ;
      while ( lMen_MenuParent.Parent is TMenuItem ) do
        lMen_MenuParent := lMen_MenuParent.Parent as TMenuItem ;

      if lMen_MenuParent.Owner is TMainMenu
       Then
        ( lMen_MenuParent.Owner as TMainMenu ).Images.GetBitmap ( ( aobj_Sender as TMenuItem ).ImageIndex, lbmp_Icon );
      if lbmp_Icon.Width > 0
       Then
        Begin
          lbmp_Icon.Transparent := True ;
          lima_Liste.AddMasked ( lbmp_Icon, lbmp_Icon.TransparentColor );
//          p_BitmapVersIco ( lbmp_Icon, Result );
            lima_Liste.GetBitmap ( lima_Liste.Count - 1, lbmp_Icon );
            p_BitmapVersIco(lbmp_Icon,Result);
//          Result.Transparent := True ;
        End ;
    End ;
    // C'est un item de bar xp
  if ( aobj_Sender is TJvXpBarItem )
   Then
    Begin

      (( aobj_Sender as TJvXpBarItem ).WinXPBar as TJvXpBar ).ImageList.GetBitmap ( ( aobj_Sender as TJvXpBarItem ).ImageIndex, lbmp_Icon );
      p_BitmapVersIco(lbmp_Icon,Result);
    End ;
    // C'est une bar xp
  if ( aobj_Sender is TJvXpBar )
   Then
    Begin
      Result.Assign ( ( aobj_Sender as TJvXpBar ).Icon  );
    End ;
  if ( lbmp_Icon.Width > 0 )
   Then
    Begin
      {$IFDEF DELPHI}
      lbmp_Icon.Dormant ;
      {$ENDIF}
      lbmp_Icon.FreeImage ;
      lbmp_Icon.Handle := 0 ;
    End ;
  Try
    lbmp_Icon.Free ;
    lima_Liste.Free ;
  finally
  End ;
End ;
// Destruction des xpbuttons
// aCom_ParentContainer : Le composant dont les composants et sous composants buttons doivent se détruire
procedure p_DetruitXPBar ( const   aCom_Parent    : TScrollingWinControl );

var li_i : Integer ;
Begin
// Rien ou quitte
  if not assigned ( aCom_Parent   )
   Then
    Exit ;
    //Recherche des composants à détruire

  with aCom_Parent do
  For li_i := ControlCount - 1 downto 0 do
    Controls [ li_i ].Destroy;
End ;
// Destruction des menus
// aCom_ParentContainer : Le menu à détruire
procedure p_DetruitMenus ( const aMen_MenuParent : TMenuItem ; aMen_MenuDetruit  : TMenuItem  ; const ab_DestroyAll : Boolean  );

var li_i : Integer ;
Begin
// DEstruction des menus
  if not assigned ( aMen_MenuDetruit )
   Then
    Exit ;
// DEstruction des items de menu
  For li_i := aMen_MenuDetruit.Count - 1 downto 0 do
    Begin
      p_DetruitMenus ( aMen_MenuDetruit, aMen_MenuDetruit.Items [ li_i ], ab_DestroyAll );
    End ;

  if aMen_MenuDetruit.Bitmap.Width > 0 Then
    Begin
      {$IFDEF DELPHI}
      aMen_MenuDetruit.Bitmap.Dormant ;
      {$ENDIF}
      aMen_MenuDetruit.Bitmap.FreeImage ;
      aMen_MenuDetruit.Bitmap.Handle := 0 ;
    End ;
  if ab_DestroyAll Then
    try
      if assigned ( aMen_MenuParent ) Then
        aMen_MenuParent.Delete ( aMen_MenuParent.IndexOf ( aMen_MenuDetruit ));
      aMen_MenuDetruit.Clear ;
      aMen_MenuDetruit.Free ;
    Except
    End ;
End ;


// Destruction du menu dans la barre des menus
// aMen_MenuParent      : Le menu parent
{
procedure  p_DetruitMenu    (  var aMen_MenuParent : TMenuItem     );

var li_i : Integer ;
begin
  for li_i := aMen_MenuParent.ComponentCount - 1 downto 0 do
    Begin
      p_DetruitComposantsDescendant ( aMen_MenuParent.Components [ li_i ] );
End ;
}
// Ajoute un évènement dans un objet xpbar
// adx_WinXpBar            : Parent
// as_Fonction             : Fonction
// as_FonctionLibelle      : Libellé de Fonction
// as_FonctionType         : Type de Fonction
// as_FonctionMode         : Mode de la Fonction
// as_FonctionNom          : Nom de la Fonction
// ai_Compteur             : Compteur de nom
function fmen_AjouteFonctionMenu  ( const aF_FormParent        : TForm     ;
                        	    const aMen_MenuParent     : TMenuItem ;
                        	    const as_Fonction          ,
                        		  as_FonctionLibelle   ,
                        		  as_FonctionType      ,
                        		  as_FonctionMode      ,
                        		  as_FonctionNom       : String      ;
                        	    const ai_Compteur          : integer     ;
                        	    const aBmp_Picture         : TBitmap     ;
                        	    const ab_AjouteBitmap      ,
                        		  ab_ImageDefaut       : Boolean     ;
                        	    const aIma_ImagesMenus     : TImageList  ;
                        	    const ai_FinCompteurImages : Integer     ):TMenuItem;
var lbmp_Tempo          : TBitmap ; // Bitmap temporaire pour garder la taille originale
Begin
  //création d'une action dans le menu ou sous menu
  Result := TMenuItem.Create( aF_FormParent );

  //Gestion des raccourcis d'aide
  Result.HelpContext := aMen_MenuParent.HelpContext ;

  aMen_MenuParent.Add ( Result );
  Result.Name    :=fs_getComponentName(aF_FormParent,as_Fonction);
  Result.Caption := as_FonctionLibelle ;
  Result.Hint    := as_FonctionLibelle ;
  lbmp_Tempo := TBitmap.Create ;
  lbmp_Tempo.Handle := 0 ;
  if ( ab_AjouteBitmap
  or ab_ImageDefaut )
  and ( aBmp_Picture.Width > 0 )
   Then
    Begin
      lbmp_Tempo.Assign ( aBmp_Picture );
      Result.ImageIndex := fi_AjouteBmpAImages (lbmp_Tempo           ,
                        			ab_AjouteBitmap      ,
                        			ab_ImageDefaut       ,
                        			aIma_ImagesMenus     ,
                        			ai_FinCompteurImages );
    End ;
  if  ( aMen_MenuParent = aMen_MenuParent   )
  and ( as_FonctionType = CST_FCT_TYPE_MENU )
   Then
     gb_ExisteFonctionMenu := True ;

  if lbmp_Tempo.Width > 0
   Then
    Begin
      {$IFDEF DELPHI}
      lbmp_Tempo.Dormant ;
      {$ENDIF}
      lbmp_Tempo.FreeImage ;
      lbmp_Tempo.Handle := 0 ;
    End ;
  try
    lbmp_Tempo.Free ;
  Finally
  End ;
End ;

// Ajoute un évènement dans un objet xpbar
// adx_WinXpBar            : Parent
// as_Fonction             : Fonction
// as_FonctionLibelle      : Libellé de Fonction
// as_FonctionType         : Type de Fonction
// as_FonctionMode         : Mode de la Fonction
// as_FonctionNom          : Nom de la Fonction
// ai_Compteur             : Compteur de nom
{procedure p_AjouteBoutonsMenus  ( const aF_FormParent        : TForm     ;
                                  const aMen_MenuParent      : TMenuItem ;
                                  var   ai_Compteur          : integer     ;
                                  const ab_ImageDefaut       : Boolean     ;
                                  const aIma_ImagesMenus     : TImageList  ;
                                  const ai_FinCompteurImages : Integer     );
var lMen_MenuEnfant    : TMenuItem ; // Nouvel item
    li_i               : Integer ;
    lbmp_MettrePetit   : TBitmap ; // Bitmap temporaire pour mettre en petit
Begin
  lbmp_MettrePetit   := TBitmap.Create ;
  for li_i := 0 to high ( gt_TableauSommaire ) do
    Begin
      inc ( ai_Compteur );
      //création d'une action dans le menu ou sous menu
      lMen_MenuEnfant := TMenuItem.Create( aF_FormParent );
      aMen_MenuParent.Add ( lMen_MenuEnfant );
      lMen_MenuEnfant.Name    := CST_MENU_NOM_DEBUT + IntToStr ( ai_Compteur );
      lMen_MenuEnfant.Caption := gt_TableauSommaire [ li_i ].Menu ;
      lMen_MenuEnfant.Hint    := gt_TableauSommaire [ li_i ].Menu ;
      if assigned ( gt_TableauSommaire [ li_i ].Image )
       Then
        lbmp_MettrePetit.Assign ( gt_TableauSommaire [ li_i ].Image );

      if assigned ( gt_TableauSommaire [ li_i ].Image )
      or ab_ImageDefaut
       Then
        lMen_MenuEnfant.ImageIndex := fi_AjouteBmpAImages ( lbmp_MettrePetit     ,
                                                            assigned ( gt_TableauSommaire [ li_i ].Image ),
                                                            ab_ImageDefaut       ,
                                                            aIma_ImagesMenus     ,
                                                            ai_FinCompteurImages );
      gb_ExisteFonctionMenu := True ;
      p_AjouteEvenement     ( aF_FormParent        ,
                              lMen_MenuEnfant      ,
                              lMen_MenuEnfant.Name ,
                              gt_TableauSommaire [ li_i ].Menu,
                              gt_TableauSommaire [ li_i ].Menu,
                              CST_FCT_TYPE_MENU    ,
                              ''                    ,
                              gt_TableauSommaire [ li_i ].Menu,
                              gt_TableauSommaire [ li_i ].Image,
                              CST_EVT_STANDARD      );
    End ;
  lbmp_MettrePetit.Dormant ;
  lbmp_MettrePetit.FreeImage ;
  lbmp_MettrePetit.Free ;
End ;
 }


// Modifie une xpbar
// adx_WinXpBar            : Parent
// as_Fonction             : Fonction
// as_FonctionLibelle      : Libellé de Fonction
// as_FonctionType         : Type de Fonction
// as_FonctionMode         : Mode de la Fonction
// as_FonctionNom          : Nom de la Fonction
// aIco_Picture            : Icône de la fonction à utiliser
// ai_Compteur             : Compteur de nom
procedure p_ModifieXPBar  ( const aF_FormParent       : TCustomForm        ;
                            const adx_WinXpBar        : TJvXpBar ;
                            const as_Fonction         ,
                                  as_FonctionLibelle  ,
                                  as_FonctionType     ,
                                  as_FonctionMode     ,
                                  as_FonctionNom      : String      ;
                            const aIma_ListeImages    : TImageList  ;
                            const abmp_Picture        ,
                                  abmp_DefaultPicture : TBitmap     ;
                            const ab_AjouteEvenement   : Boolean   );
var lbmp_Bitmap : TBitmap ;
Begin
  //création d'une action dans la bar XP
// Transformation d'un champ bitmap en TIcon
  adx_WinXpBar.Caption := as_FonctionLibelle ;
  adx_WinXpBar.ShowRollButton := False ;
  lbmp_Bitmap := nil;
{  if assigned ( aico_IconTableau )
   then
      Begin
        adx_WinXpBar.Icon.ReleaseHandle ;
        adx_WinXpBar.Icon.Assign ( aico_IconTableau );
      End
   else}
  if  ( abmp_Picture.Width > 0  )
  and ( abmp_Picture.Width  =  aIma_ListeImages.Width  )
  and ( abmp_Picture.Height =  aIma_ListeImages.Height )
     Then
      Begin
{        if adx_WinXpBar.Icon.Handle <> 0
         Then
          adx_WinXpBar.Icon.ReleaseHandle ;
        adx_WinXpBar.Icon.Handle := 0 ;}
        aIma_ListeImages.AddMasked ( abmp_Picture               , abmp_Picture.TransparentColor );
        aIma_ListeImages.GetBitmap   ( aIma_ListeImages.Count - 1 , lbmp_Bitmap );
        p_BitmapVersIco ( lbmp_Bitmap, adx_WinXpBar.Icon );
      End
      else if assigned ( abmp_DefaultPicture )
      and  ( abmp_DefaultPicture.Width > 0  )
       Then
        Begin
{          if adx_WinXpBar.Icon.Handle <> 0
           Then
            adx_WinXpBar.Icon.ReleaseHandle ;
          adx_WinXpBar.Icon.Handle := 0 ;}
          aIma_ListeImages.AddMasked ( abmp_DefaultPicture        , abmp_DefaultPicture.TransparentColor );
          aIma_ListeImages.GetBitmap   ( aIma_ListeImages.Count - 1 , lbmp_Bitmap );
          p_BitmapVersIco ( lbmp_Bitmap, adx_WinXpBar.Icon );
        End ;
   if ab_AjouteEvenement then
      p_AjouteEvenement     ( aF_FormParent         ,
                              adx_WinXpBar          ,
                              as_Fonction           ,
                              CST_FONCTION_CLICK    ,
                              CST_EVT_STANDARD      );

End ;

{
procedure p_initialisationBoutonToolBar ( const ai_BoutonClick           : Integer       );
Begin
  gi_BoutonClick          := ai_BoutonClick          ;
End ;
// Initialisation du bouton toolbar à partir du fichier INI
// Sortie          : Variable initialisée à partir du fihcier ini pour sauver la xpbar en cours
function fi_RecupereBoutonToolBar : Integer       ;
Begin
  Result         := gi_BoutonClick          ;
End ;}
// Destruction du sommaire
// aBar_ToolBarParent      : La tool barre parent
// aSep_ToolBarSepareDebut : Le séparateur de début
// aSep_ToolBarSepareFin   : Le séparateur de fin

procedure  p_DetruitSommaire (      const aBar_ToolBarParent      : {$IFDEF FPC}TCustomControl{$ELSE}TToolWindow{$ENDIF} ;
                                    const aSep_ToolBarSepareDebut : TControl;
                                    const aPan_PanelSepareFin     : TWinControl  );
var li_i : integer ;
Begin
  if not assigned ( aBar_ToolBarParent              )
  or not assigned ( aSep_ToolBarSepareDebut         )
  or not assigned ( aPan_PanelSepareFin             )
   Then
    Exit ;
  for li_i := aBar_ToolBarParent.ControlCount - 1 downto 0 do
    if  ( aBar_ToolBarParent.Controls [ li_i ] is TControl )
    and (( aBar_ToolBarParent.Controls [ li_i ] as TControl ).Parent = aBar_ToolBarParent )
    and ( ( aBar_ToolBarParent.Controls [ li_i ] as TControl ).Left >  aSep_ToolBarSepareDebut.Left)
    and (  ( aBar_ToolBarParent.Controls [ li_i ] as TControl ).Left <  aPan_PanelSepareFin.Left)
//    and ( aBar_ToolBarParent.OrderIndex [ ( aBar_ToolBarParent.Controls [ li_i ] as TControl )] > aBar_ToolBarParent.OrderIndex [ aSep_ToolBarSepareDebut ])
//    and ( aBar_ToolBarParent.OrderIndex [ ( aBar_ToolBarParent.Controls [ li_i ] as TControl )] < aBar_ToolBarParent.OrderIndex [ aPan_PanelSepareFin     ])
     Then
        aBar_ToolBarParent.Controls [ li_i ].Free;
End ;
// ReValide les boutons du sommaire
// aBar_ToolBarParent      : La tool barre parent
// aSep_ToolBarSepareDebut : Le séparateur de début
// aSep_ToolBarSepareFin   : Le séparateur de fin

procedure  p_EnableSommaire (       const aBar_ToolBarParent      : {$IFDEF FPC}TCustomControl{$ELSE}TToolWindow{$ENDIF}   ;
                                    const aSep_ToolBarSepareDebut : TControl;
                                    const aPan_PanelSepareFin     : TWinControl  );
var li_i : integer ;
Begin
  if not assigned ( aBar_ToolBarParent              )
  or not assigned ( aSep_ToolBarSepareDebut         )
  or not assigned ( aPan_PanelSepareFin             )
   Then
    Exit ;
  for li_i := aBar_ToolBarParent.ControlCount - 1 downto 0 do
    if  ( aBar_ToolBarParent.Controls [ li_i ] is TControl )
    and ( ( aBar_ToolBarParent.Controls [ li_i ] as TControl ).Left >  aSep_ToolBarSepareDebut.Left)
    and (  ( aBar_ToolBarParent.Controls [ li_i ] as TControl ).Left <  aPan_PanelSepareFin.Left)
     Then
      aBar_ToolBarParent.Controls [ li_i ].Enabled := True ;
End ;

// Message d'erreur sur l'affectation de la fonction en propriété

// as_Fonction          : la fonction en propriété
// as_MethodeType       : Le type demandé correct
// as_MethodeParametres : Les paramètres du type de la méthode
// aF_FormParentClasse  : Le type immédiat de la classe form  Propriété CLassName

procedure p_ShowMessageMethode ( const as_Fonction          ,
                                       as_Evenement         ,
                                       aF_FormParentClasse  ,
                                       aCom_ComposantClasse : String );
Begin
  ShowMessage ( 'La méthode propriété ' + as_Fonction + ' de ' + aF_FormParentClasse + ' doit être du même type  que ' + #13#10
              + 'l''évènement ' +  as_Evenement + ' de ' + aCom_ComposantClasse + '.'  );

End ;


// Ajoute un évènement dans un objet xpbar
// adx_WinXpBar            : Parent
// as_Fonction             : Fonction
// as_FonctionLibelle      : Libellé de Fonction
// as_FonctionType         : Type de Fonction
// as_FonctionMode         : Mode de la Fonction
// as_FonctionNom          : Nom de la Fonction
// ai_CompteurNom          : Compteur de nom d'objet
function fdxi_AddItemXPBar  ( const aF_FormParent       : TCustomForm        ;
                        			const adx_WinXpBar        : TJvXpBar ;
                        			const as_Fonction         ,
                        			      as_FonctionLibelle  ,
                        			      as_FonctionType     ,
                        			      as_FonctionMode     ,
                        			      as_FonctionNom      : String      ;
                        			const aIma_ImagesXPBars   : TImageList  ;
                        			const abmp_FonctionBmp    : TBitmap     ;
                        			const aBmp_DefaultPicture : TBitmap     ;
                        			const ai_CompteurNom      : integer     ): TJvXpBarItem ;
var lbmp_Tempo          : TBitmap ; // Bitmap temporaire pour garder la taille originale
Begin
  //création d'une action dans la bar XP
//  adx_WinXpBar.RollMode := rmFixed;
  if adx_WinXpBar = nil
   Then
    Begin
     Result:=nil;
     Exit;
    end;
  Result := TJvXpBarItem.Create( adx_WinXpBar.Items );
  Result.Name := fs_getComponentNameXPBar(adx_WinXpBar,as_Fonction);
  Result.ImageList := aIma_ImagesXPBars ;
  Result.Caption := as_FonctionLibelle ;

  p_AjouteEvenement   ( aF_FormParent         ,
                        Result      ,
                        as_Fonction ,
                        CST_FONCTION_CLICK    ,
                        CST_EVT_STANDARD      );

  lbmp_Tempo := TBitmap.Create ;
  lbmp_Tempo.Handle := 0 ;
  if ( aBmp_FonctionBmp.Width > 0 )
   Then
    Begin
      lbmp_Tempo.Assign ( aBmp_FonctionBmp );
      Result.ImageIndex := fi_AjouteBmpAImages ( aBmp_FonctionBmp, aIma_ImagesXPBars );
    End
    else if ( aBmp_DefaultPicture <> nil )
    and ( aBmp_DefaultPicture.Width > 0 )
     Then
      Result.ImageIndex := fi_AjouteBmpAImages ( lbmp_Tempo, aIma_ImagesXPBars );
//  adx_WinXpBar.Refresh ;
  if lbmp_Tempo.Width > 0
   Then
    Begin
      {$IFDEF DELPHI}
      lbmp_Tempo.Dormant ;
      {$ENDIF}
      lbmp_Tempo.FreeImage ;
      lbmp_Tempo.Handle := 0 ;
    End ;
  try
    lbmp_Tempo.Free ;
  Finally
  End ;
End ;
// Ajoute un évènement dans un objet
// aObj_Objet              : Propriétaire
// as_Fonction             : Fonction
// as_FonctionLibelle      : Libellé de Fonction
// as_FonctionType         : Type de Fonction
// as_FonctionMode         : Mode de la Fonction
// as_FonctionNom          : Nom de la Fonction
procedure p_AjouteEvenement       ( const aF_FormParent       : TComponent  ;
        			    const aObj_Objet          : TObject     ;
        			    const as_Fonction         ,
                                          as_EventForm        ,
        			          as_Evenement        : String     );
Var ls_MessageErreur ,
    ls_ObjetNom      : String;
    lMet_MethodForm  : TMethod ;
Begin
  if  ( aObj_Objet is TComponent )
  and ( as_Fonction <> '' ) Then
    Begin
      ls_ObjetNom := fs_getComponentName( aF_FormParent, as_Fonction );
      p_SetComponentProperty ( aObj_Objet as TComponent, 'Name', ls_ObjetNom );
    end;
  //création d'une action dans la bar XP
  if ( aF_FormParent.ClassNameIs ( 'TF_Administration' )) or (aF_FormParent.ClassNameIs ( 'TF_DBEAdministration' ))
   Then
    exit ;

    //Gestion des erreurs : les fonctions enregistrées sont alors à modifier
  ls_MessageErreur := 'Erreur !'  + #13#10;
  if assigned ( aObj_Objet ) Then
    Begin
      lMet_MethodForm.Data := aF_FormParent;
      if not assigned ( aF_FormParent.MethodAddress ( as_EventForm ))
       Then
        ls_MessageErreur :=  ls_MessageErreur + 'Méthode ' + as_EventForm + ' de ' + aF_FormParent.ClassName + ' inexistante.' + #13#10 ;

      if not IsPublishedProp ( aObj_Objet    , as_Evenement           )
       Then
        ls_MessageErreur := ls_MessageErreur + 'Evènement ' + as_Evenement + ' de ' + aObj_Objet.ClassName + ' non publiée.' +  #13#10
       else if not PropIsType      ( aObj_Objet    , as_Evenement, tkMethod )
        Then ls_MessageErreur :=  'Propriété ' + as_Evenement + ' de ' + aObj_Objet.ClassName + ' n''est pas une méthode.' + #13#10 ;
      if  assigned ( aF_FormParent.MethodAddress ( as_EventForm ))
      and IsPublishedProp ( aObj_Objet    , as_Evenement           )
      and PropIsType      ( aObj_Objet    , as_Evenement, tkMethod )
       Then
        try
          lMet_MethodForm.Code := aF_FormParent.MethodAddress ( as_EventForm );
          SetMethodProp ( aObj_Objet, as_Evenement, lMet_MethodForm );
        Except
        // Message d'erreur : Mauvais type de méthode
          p_ShowMessageMethode ( as_EventForm, as_Evenement, aF_FormParent.ClassName , aObj_Objet.ClassName );
        End
      else
        //Gestion des erreurs : les fonctions enregistrées sont alors à modifier
         ShowMessage ( ls_MessageErreur );
    End ;
End ;

// Recherche d'un composant avec un nom
// En rapport avec la Procedure d'affection d'un nom contenant la clé d'une fonction leonardi avec un chiffre de taille 1
function fcom_FindComponent ( const as_Name : String ; const AOwner : TComponent ): TComponent;
var li_i, li_j, li_Max : Longint ;
    lcom_Component  : TComponent ;
Begin
  Result := nil;
  li_Max := -1 ;
  for li_i := 0 to AOwner.ComponentCount - 1 do
    if  ( pos ( as_Name, AOwner.Components [ li_i ].Name ) = 1 )
    and ( length ( as_Name ) = length ( AOwner.Components [ li_i ].Name ) - 1 )  then
      Begin
        lcom_Component := AOwner.Components [ li_i ];
        li_j := StrToInt ( copy ( lcom_Component.Name, length ( lcom_Component.Name ), 1 ));
        if li_Max < li_j then
          Begin
            Result := lcom_COmponent;
            li_max := li_j ;
          End;
      End;
End;



// Procedure d'affection d'un nom contenant la clé d'une fonction leonardi avec un chiffre de taille 1
procedure p_setComponentName ( const acom_Component : TComponent ; const as_Name : String );
Begin
  acom_Component.Name := fs_getComponentName ( acom_Component.owner, as_Name );
End;
// Fonction de création d'un nom contenant la clé d'une fonction leonardi avec un chiffre de taille 1
function fs_getComponentName ( const acom_Owner : TComponent ; const as_Name : String ):String;
var lcom_Component      : TComponent ;
Begin
  lcom_Component := fcom_FindComponent ( as_Name, acom_Owner );
  if lcom_Component = nil then
    Begin
      Result := as_Name + '0' ;
    End
   Else
    try
      Result := as_Name + IntToStr ( StrToInt ( copy ( lcom_Component.Name, length ( lcom_Component.Name ), 1 )) + 1 );
    Except
      On E : Exception do
        Begin
          Showmessage ( Gs_InvalidComponentName  + lcom_Component.Name + '.' );
        End;
    End
End;

// Fonction de création d'un nom contenant la clé d'une fonction leonardi avec un chiffre de taille 1
function fs_getComponentNameXPBar ( const adx_WinXpBar        : TJvXpBar ; const as_Name : String ):String;
//var lxpi_Item      : TJvXpBarItem ;
Begin
{  lxpi_Item := fxpi_FindComponentXPBarItems ( as_Name, adx_WinXpBar );
  if lxpi_Item = nil then
    Begin}
      Result := as_Name + '0' ;
{    End
   Else
    try
      Result := as_Name + IntToStr ( StrToInt ( copy ( lxpi_Item.Name, length ( lxpi_Item.Name ), 1 )) + 1 );
    Except
      On E : Exception do
        Begin
          Showmessage ( Gs_InvalidXPBARItemName  + lxpi_Item.Name + '.' );
        End;
    End}
End;

// Ajoute un évènement dans un objet xpbar
// adx_WinXpBar            : Parent
// as_Fonction             : Fonction
// as_FonctionLibelle      : Libellé de Fonction
// as_FonctionType         : Type de Fonction
// as_FonctionMode         : Mode de la Fonction
// as_FonctionNom          : Nom de la Fonction
// ai_Compteur             : Compteur de nom
procedure p_AjouteFonctionMenu  ( const aF_FormParent        : TForm     ;
                        			    const aMen_MenuParent     : TMenuItem ;
                        			    const as_Fonction          ,
                        			          as_FonctionLibelle   ,
                        			          as_FonctionType      ,
                        			          as_FonctionMode      ,
                        			          as_FonctionNom       : String      ;
                        			    const ai_Compteur          : integer     ;
                        			    const aBmp_Picture         : TBitmap     ;
                        			    const ab_AjouteBitmap      ,
                        			          ab_ImageDefaut       : Boolean     ;
                        			    const aIma_ImagesMenus     : TImageList  ;
                        			    const ai_FinCompteurImages : Integer     );
var lMen_MenuEnfant    : TMenuItem ; // Nouvel item
    lbmp_Tempo          : TBitmap ; // Bitmap temporaire pour garder la taille originale
Begin
  lMen_MenuEnfant := fmen_AjouteFonctionMenu(aF_FormParent        ,
                    			     aMen_MenuParent      ,
                    			     as_Fonction          ,
                    			     as_FonctionLibelle   ,
                    			     as_FonctionType      ,
                    			     as_FonctionMode      ,
                    			     as_FonctionNom       ,
                    			     ai_Compteur          ,
                    			     aBmp_Picture         ,
                    			     ab_AjouteBitmap      ,
                    			     ab_ImageDefaut       ,
                    			     aIma_ImagesMenus     ,
                    			     ai_FinCompteurImages );
  p_AjouteEvenement   ( aF_FormParent         ,
                        lMen_MenuEnfant       ,
                        as_Fonction          ,
                        CST_FONCTION_CLICK       ,
                        CST_EVT_STANDARD         );

End ;

// procedure p_setImageToMenuAndXPButton
// Set the xpbutton and menu from prefix
procedure p_setImageToMenuAndXPButton ( const abmp_Bitmap: TBitmap;
                                        const axb_Button  : TJvXPButton ;
                                        const amen_Menu   : TMenuItem ;
                                        const aiml_Images : TImageList );
Begin
  p_ChangeTailleBitmap(abmp_Bitmap,32);
  abmp_Bitmap.TransparentColor:=clBlack;
  abmp_Bitmap.Transparent:=True;
  axb_Button.Glyph.Assign(abmp_Bitmap);
  p_ChangeTailleBitmap(abmp_Bitmap,16);
  amen_Menu.ImageIndex := fi_AjouteBmpAImages ( abmp_Bitmap  ,
                    			        True         ,
                    			        False        ,
                    			        aiml_Images  ,
                    			        0 );
  ScaleDPIControl(axb_Button);
end;



{$IFDEF VERSIONS}
initialization
  p_ConcatVersion ( gVer_fonctions_Objets_Dynamiques );
{$ENDIF}
finalization
{$IFDEF TNT}
//  Languages.Free;
//  Languages := nil;
{$ENDIF}
end.
